open F

(* A type-checker for System F. *)

(* [typeof t] type-checks the closed term [t] and constructs its type. *)

type arity_requirement = Index of int | Total of int

type type_error =
  | TypeMismatch of debruijn_type * debruijn_type
  | ArityMismatch of arity_requirement * debruijn_type
  | NotAnArrow of debruijn_type
  | NotAProduct of debruijn_type
  | NotAForall of debruijn_type
  | UnboundTermVariable of tevar
  | TwoOccurencesOfSameVariable of string
                   
exception TypeError of type_error

val typeof: debruijn_term -> debruijn_type

